RTB_registerPref("Color Code 1", "Admin Chat", "$AC::Color1", "string 100", "Server_AdminChat", "<color:26FF00>", 0, 0, "");
RTB_registerPref("Color Code 2", "Admin Chat", "$AC::Color2", "string 100", "Server_AdminChat", "<color:00FFEA>", 0, 0, "");
RTB_registerPref("Color Code 3", "Admin Chat", "$AC::Color3", "string 100", "Server_AdminChat", "<color:FFFB00>", 0, 0, "");
RTB_registerPref("Shorten", "Admin Chat", "$AC::Shorten", "bool", "Server_AdminChat", true, 0, 0, "");
RTB_registerPref("Delimiter", "Admin Chat", "$AC::Delimiter", "string 1", "Server_AdminChat", "@", 0, 0, "");

function serverCmdAC(%client, %Chat, %Chat2, %Chat3, %Chat4, %Chat5, %Chat6, %Chat7, %Chat8, %Chat9, %Chat10, %Chat11, %Chat12, %Chat13, %Chat14, %Chat15, %Chat16) {
	adminChat(%client, trim(%chat SPC %chat2 SPC %chat3 SPC %chat4 SPC %chat5 SPC %chat6 SPC %chat7 SPC %chat8 SPC %chat9 SPC %chat10 SPC %chat11 SPC %chat12 SPC %chat13 SPC %chat14 SPC %chat15 SPC %chat16));
}

function serverCmdSAC(%client, %Chat, %Chat2, %Chat3, %Chat4, %Chat5, %Chat6, %Chat7, %Chat8, %Chat9, %Chat10, %Chat11, %Chat12, %Chat13, %Chat14, %Chat15, %Chat16) {
	superAdminChat(%client, trim(%chat SPC %chat2 SPC %chat3 SPC %chat4 SPC %chat5 SPC %chat6 SPC %chat7 SPC %chat8 SPC %chat9 SPC %chat10 SPC %chat11 SPC %chat12 SPC %chat13 SPC %chat14 SPC %chat15 SPC %chat16));
}

function adminChatPrepString(%message) {
	%message = StripMLControlChars(%message);
	%message = trim(%message);


	for(%i = 0; %i < getWordCount(%message); %i++) {
		%word = getWord(%message, %i);

		if(strpos(%word, "http://") == 0 || strpos(%word, "https://") == 0) {
			%url = getSubStr(%word, strpos(%word, "://")+3, strlen(%word));
			%link = "<a:" @ %word @ ">" @ %url @ "</a>";
			%message = setWord(%message, %i, %link);
		}
	}

	return %message;
}

function superAdminChat(%client, %message) {
	if(%client.isSuperAdmin) {
		%message = adminChatPrepString(%message);
		if(strlen(%message) == 0) return;


		%str = $AC::Color1 @ ($AC::Shorten ? "SAC" : "SuperAdminChat") @ "(" @ $AC::Color2 @ %client.name @ $AC::Color1 @ ")" @ $AC::Color3 @": "@ %message;

		for(%i = 0; %i < ClientGroup.getCount(); %i++) {
			%clientB = ClientGroup.getObject(%i);
			if(%clientB.isSuperAdmin) {
				messageClient(%clientb, '', %str);
			}
		}
	} else {
		messageClient(%client, '', "\c3You are not a super admin!");
	}
}

function adminChat(%client, %message) {
	if(%client.isAdmin) {
		%message = adminChatPrepString(%message);
		if(strlen(%message) == 0) return;

		%str = $AC::Color1 @ ($AC::Shorten ? "AC" : "AdminChat") @ "(" @ $AC::Color2 @ %client.name @ $AC::Color1 @ ")" @ $AC::Color3 @": "@ %message;

		for(%i = 0; %i < ClientGroup.getCount(); %i++) {
			%clientB = ClientGroup.getObject(%i);

			if(%clientB.isAdmin) {
				messageClient(%clientb, '', %str);
			}
		}
	} else {
		messageClient(%client, '', "\c3You are not an admin!");
	}
}

package AdminChat {
	function serverCmdMessageSent(%cl, %message) {
		if(strlen(%message) > 0 && getSubStr(%message, 0, 1) $= $AC::Delimiter) {
			%valid = "!@#$%^&*<>\\?,.";
			if(strpos(%valid, $AC::Delimiter) > -1) {
				adminChat(%cl, getSubStr(%message, 1, strlen(%message)-1));
			} else {
				//invalid delimiter?
				$AC::Delimiter = "@";
			}
			return;
		}

		return parent::serverCmdMessageSent(%cl, %message);
	}

	function GameConnection::autoAdminCheck(%cl, %a) {
		%ret = parent::autoAdminCheck(%cl, %a);

		messageClient(%cl, '', "<color:ffffff>The admin chat delimiter is <color:ffff00>" @ $AC::Delimiter);
	}
};
activatePackage(AdminChat);
